"""
Licensed to the Apache Software Foundation (ASF) under one
or more contributor license agreements.  See the NOTICE file
distributed with this work for additional information
regarding copyright ownership.  The ASF licenses this file
to you under the Apache License, Version 2.0 (the
"License"); you may not use this file except in compliance
with the License.  You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing,
software distributed under the License is distributed on an
"AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, either express or implied.  See the License for the
specific language governing permissions and limitations
under the License.
"""

# -*- coding: utf-8 -*-


class InfoDict(dict):

    def __init__(self, *args, **kwargs):

        super(InfoDict, self).__init__(*args, **kwargs)

    def get_as_int(self, key, default=None):

        value = self.get(key, None)
        if value is not None:
            try:
                value = Integer(value)
            except:
                #if default is not None:
                value = default
        return value

    def get_as_str(self, key):

        return self.get(key, None)


class Integer(int):

    def __new__(cls, *args, **kwargs):

        return  super(Integer, cls).__new__(cls, *args, **kwargs)

    def percentage(self, whole):

        return Float(100 * float(self) / whole)

    def is_greater_than(self, num):

        return self > num

    def is_less_than(self, num):

        return self < num


class Float(float):

    def __new__(cls, *args, **kwargs):

        return  super(Float, cls).__new__(cls, *args, **kwargs)

    def percentage(self, whole):

        return Float(100 * self / whole)

    def is_greater_than(self, num):

        return self > num

    def is_less_than(self, num):

        return self < num
