"""
Licensed to the Apache Software Foundation (ASF) under one
or more contributor license agreements.  See the NOTICE file
distributed with this work for additional information
regarding copyright ownership.  The ASF licenses this file
to you under the Apache License, Version 2.0 (the
"License"); you may not use this file except in compliance
with the License.  You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing,
software distributed under the License is distributed on an
"AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, either express or implied.  See the License for the
specific language governing permissions and limitations
under the License.
"""

# -*- coding: utf-8 -*-
from flask import current_app
from constants import AMC_CONFIG_PATH
try:
    import ConfigParser as cp
except ImportError:
    import configparser as cp


def get_update_interval():

    try:
        config = cp.RawConfigParser()
        config.read(AMC_CONFIG_PATH)
        return config.getint('AMC', 'update_interval')
    except Exception:
        return dict(update_interval="failure")


def set_update_interval(update_interval):

    try:
        config = cp.RawConfigParser()
        config.add_section('AMC')
        config.set('AMC', 'update_interval', update_interval)
        with open(AMC_CONFIG_PATH, 'wb') as configfile:
            config.write(configfile)
        current_app.config["UPDATE_INTERVAL"] = int(update_interval)
        return dict(status="success")
    except Exception:
        return dict(status="failure")
